'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RouteHandler = require('./RouteHandler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BundleLoader = function (_Component) {
  _inherits(BundleLoader, _Component);

  function BundleLoader() {
    var _this2 = this;

    _classCallCheck(this, BundleLoader);

    var _this = _possibleConstructorReturn(this, (BundleLoader.__proto__ || Object.getPrototypeOf(BundleLoader)).call(this));

    _this.loadbundle = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
      var bundle, routeBundle;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              bundle = _this.props.bundle;
              _context.next = 3;
              return bundle.load();

            case 3:
              routeBundle = _context.sent;


              _this.setState({ mod: routeBundle.default });

            case 5:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    }));

    _this.state = { mod: null };
    return _this;
  }

  _createClass(BundleLoader, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.loadbundle();
    }
  }, {
    key: 'render',
    value: function render() {
      var mod = this.state.mod;

      if (!mod) {
        return null;
      }

      var _props = this.props,
          path = _props.path,
          serverProps = _props.serverProps,
          meta = _props.meta;

      var props = { component: mod, path: path, serverProps: serverProps, meta: meta };

      return _react2.default.createElement((0, _RouteHandler.renderRoute)(props));
    }
  }]);

  return BundleLoader;
}(_react.Component);

BundleLoader.defaultProps = {};
BundleLoader.contextTypes = {
  router: _propTypes2.default.any
};
exports.default = BundleLoader;