'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (config, contextRoute) {
  var _config$context = config.context,
      context = _config$context === undefined ? _path2.default.resolve(process.cwd(), './src') : _config$context;
  var bundle = contextRoute.bundle,
      component = contextRoute.component;


  if (typeof bundle !== 'undefined') {
    var componentPath = _path2.default.resolve(process.cwd(), context + '/' + bundle.location + '.js');
    return require(componentPath).default;
  }
  return component;
};