'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createOutputFolder = require('./utils/build/createOutputFolder');

var _createOutputFolder2 = _interopRequireDefault(_createOutputFolder);

var _generateWebpackOutput = require('./utils/build/generateWebpackOutput');

var _generateWebpackOutput2 = _interopRequireDefault(_generateWebpackOutput);

var _mapStatsToOutput = require('./utils/build/mapStatsToOutput');

var _mapStatsToOutput2 = _interopRequireDefault(_mapStatsToOutput);

var _hooks = require('./hooks');

var _hooks2 = _interopRequireDefault(_hooks);

var _messaging = require('./utils/messaging/messaging');

var _messaging2 = _interopRequireDefault(_messaging);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _hooks2.default)();

exports.default = function (config) {
  return (0, _createOutputFolder2.default)(config).then((0, _generateWebpackOutput2.default)(config)).then(_mapStatsToOutput2.default).catch(_messaging2.default);
};