'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('babel-polyfill');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getClientProps = function getClientProps() {
  try {
    var scriptsEl = document.getElementById('app-props');
    var props = scriptsEl ? scriptsEl.textContent : {};

    //  eslint-disable-next-line
    props = props.replace("<![CDATA[", "").replace("]]>", "");
    return JSON.parse(props);
  } catch (err) {
    throw new Error('Error parsing client props');
  }
};


var createClient = function createClient(config) {
  var serverProps = getClientProps();

  var Root = config.root;

  return _react2.default.createElement(
    _reactRouterDom.BrowserRouter,
    null,
    _react2.default.createElement(Root, serverProps)
  );
};

exports.default = createClient;