'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _webpack3 = require('./../../webpack/webpack.config');

var _webpack4 = _interopRequireDefault(_webpack3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleError = function handleError(err) {
  throw new Error(err);
};

exports.default = function (config) {
  return function () {
    return new Promise(function (resolve) {
      (0, _webpack2.default)((0, _webpack4.default)(config), function (err, stats) {
        if (err) handleError(err);
        resolve(stats);
      });
    });
  };
};